//+------------------------------------------------------------------+
//|                                                     Objecter.mqh |
//|                                                        AdvisorTC |
//|                                              http://AdvisorTC.ru |
//+------------------------------------------------------------------+
#property copyright "AdvisorTC"
#property link      "http://AdvisorTC.ru"
#property version   "2.2"
#property description "      "
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CObjecter
  {
private:

public:
                     CObjecter();
                    ~CObjecter();
   void              DeleteObjects(string prefixName);
   void              CreateLabel(string name,int corner,int x,int y,int window,
                                 string text,color col,int fontSize,string fontName,
                                 bool isSelectable,ENUM_ANCHOR_POINT anchor,string toolTipText);
   void              CreateText(string name,datetime time1,double price1,
                                string text,color col,int fontSize,string fontName);
   bool              CreateEventLabel(long chart_ID,string name,int window,
                                      string text,datetime time,color clr);
   bool              CreateArrow(long chart_ID,string name,int window,string text,
                                 datetime time,double price,color clr);
   bool              CreateVLine(long chart_ID,string name,int window,
                                 string text,datetime time,color clr,
                                 ENUM_LINE_STYLE style,long z_order=0);
   //--- 2.0
   string            TrendLineToString(string name,string delimeter="/");
   string            TextObjectToString(string name,string delimeter="/");
   string            LabelObjectToString(string name,string delimeter="/");
   //--- 2.1  
   string            ObjectToString(long chartID,string name,string delimeter="/");
  };
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+
CObjecter::CObjecter()
  {
  }
//+------------------------------------------------------------------+
//|                                                        |
//+------------------------------------------------------------------+
CObjecter::~CObjecter()
  {
  }
//+------------------------------------------------------------------+

//+--------------------------------------------------------------2.2-+
//|  ( )                              |
//+------------------------------------------------------------------+
CObjecter::CreateLabel(string name,//  
                       int corner, //      (0 - ; 1 - ; 2 -; 3 - ) 
                       int x,//  
                       int y,
                       int window,//   
                       string text,//   
                       color col,// 
                       int fontSize,//  
                       string fontName,//  
                       bool isSelectable=true,//    
                       ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER,//    
                       string toolTipText="\n" //  
                       )
  {
   if(ObjectFind(name)==-1) { ObjectCreate(name,OBJ_LABEL,window,0,0); }
   ObjectSetText(name,text,fontSize,fontName,col);
   ObjectSetInteger(0,name,OBJPROP_CORNER,corner);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
//---    
   ObjectSetInteger(0,name,OBJPROP_SELECTABLE,isSelectable);
//--- 
   //ObjectSetInteger(0,name,OBJPROP_ZORDER,1);
//---    
   ObjectSetInteger(0,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetString(0,name,OBJPROP_TOOLTIP,toolTipText);

  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  .                                    |
//+------------------------------------------------------------------+
CObjecter::CreateText(string name,datetime time1,double price1,
                      string text,color col,int fontSize,string fontName)
  {
   int type=OBJ_TEXT;

//  
   if(ObjectFind(name)==-1)
     {
      ObjectCreate(name,type,0,time1,price1);
      //ObjectCreate(name, type, 0, time1, price1);
     }
   else
     {
      //ObjectSet("z" + name, OBJPROP_PRICE1, price1);
      //ObjectSet("z" + name, OBJPROP_TIME1, time1);    
      ObjectSet(name,OBJPROP_PRICE1,price1);
      ObjectSet(name,OBJPROP_TIME1,time1);
     }

   ObjectSetText(name,text,fontSize,fontName,col);
//ObjectSetText(name, "gggggggggggggggggg", sizeFont + 1, "Webdings", Honeydew);
//ObjectSet(name, OBJPROP_COLOR, col);
   ObjectSet(name,OBJPROP_BACK,false);
// ObjectSet(name, OBJPROP_BACK, false);

  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                          |
//|	prefixName -     								|
//+------------------------------------------------------------------+
CObjecter::DeleteObjects(string prefixName)
  {
   int countObjects=ObjectsTotal();
   string nameObject="";

   for(int i=countObjects; i>=0; i--)
     {
      nameObject=ObjectName(i);
      if(StringFind(nameObject,prefixName,0)>=0)
        {
         ObjectDelete(nameObject);
        }
     }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  ( )  -                 1.1|
//+------------------------------------------------------------------+
bool CObjecter::CreateEventLabel(long chart_ID,// ID 
                                 string name,//  
                                 int window,//  
                                 string text,//      
                                 datetime time,// 
                                 color clr// 
                                 )
  {
//    ,      
   if(!time) { time=TimeCurrent(); }
//   
   ResetLastError();

//   ""
   if(ObjectFind(name)==-1)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_EVENT,window,time,0))
        {
         Print(__FUNCTION__,
               ":     \"\"!   = ",GetLastError());
         return(false);
        }
     }

//  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//   ,   
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,1);
//     
   ChartRedraw();
   Sleep(50);

//  
   return(true);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  ( )                        1.1|
//+------------------------------------------------------------------+
bool CObjecter::CreateVLine(long chart_ID,// ID 
                            string name,//  
                            int window,//  
                            string text,//      
                            datetime time,// 
                            color clr,// 
                            ENUM_LINE_STYLE style,//  
                            long z_order=0 //    
                            )
  {
//---    ,      
   if(!time) { time=TimeCurrent(); }
//---   
   ResetLastError();

//---   ""
   if(ObjectFind(name)==-1)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_VLINE,window,time,0))
        {
         Print(__FUNCTION__,
               ":     \" \"!   = ",GetLastError());
         return(false);
        }
     }

//---  
   if(ObjectGetString(chart_ID,name,OBJPROP_TEXT)!=text)
     {
      ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
     }

//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   ,   
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,1);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);

//---     
//ChartRedraw();
//Sleep(50);

//---  
   return(true);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  ( )                          1.1|
//+------------------------------------------------------------------+
bool CObjecter::CreateArrow(long chart_ID,// ID 
                            string name,//  
                            int window,//  
                            string text,//      
                            datetime time,// 
                            double price,
                            color clr//                             
                            )
  {
//    ,      
   if(!time) { time=TimeCurrent(); }
//   
   ResetLastError();

//   ""
   if(ObjectFind(name)==-1)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_ARROW,window,time,price))
        {
         Print(__FUNCTION__,
               ":     \"\"!   = ",GetLastError());
         return(false);
        }
     }

//  
   ObjectSetInteger(chart_ID,name,OBJPROP_ARROWCODE,252);
//  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//     
   ChartRedraw();
   Sleep(50);

//  
   return(true);
  }
//+------------------------------------------------------------------+

//+--------------------------------------------------------------2.0-+
//|                                       |
//+------------------------------------------------------------------+

string CObjecter::TrendLineToString(string name,string delimeter="/")
  {
   string type,price1,price2,text,style,width;
   datetime time1,time2;
   color ccolor=clrRed;
   bool isRay;

   type=IntegerToString(ObjectType(name));
   time1=(datetime)ObjectGet(name, OBJPROP_TIME1);
   time2=(datetime)ObjectGet(name, OBJPROP_TIME2);

   price1=DoubleToString(ObjectGet(name, OBJPROP_PRICE1),Digits());
   price2=DoubleToString(ObjectGet(name, OBJPROP_PRICE2),Digits());

   text=ObjectDescription(name);
   ccolor=(color)ObjectGet(name,OBJPROP_COLOR);
   style=(string)ObjectGet(name,OBJPROP_STYLE);
   width=(string)ObjectGet(name,OBJPROP_WIDTH);
   isRay=(bool)ObjectGet(name,OBJPROP_RAY);

//---  
   string result=name+delimeter+
                 type+delimeter+
                 TimeToStr(time1)+delimeter+
                 TimeToStr(time2)+delimeter+
                 price1+delimeter+
                 price2+delimeter+
                 text+delimeter+
                 ColorToString(ccolor)+delimeter+
                 style+delimeter+
                 width+delimeter+
                 IntegerToString(isRay);

   return(result);
  }
//+------------------------------------------------------------------+

//+--------------------------------------------------------------2.0-+
//|     (TEXT_OBJ)                |
//+------------------------------------------------------------------+
string CObjecter::TextObjectToString(string name,string delimeter="/")
  {
   string type,price1,text,sizeFont,angle;
   datetime time1;
   color ccolor=clrRed;

   type=IntegerToString(ObjectType(name));
   time1=(datetime)ObjectGet(name,OBJPROP_TIME1);
   price1=DoubleToString(ObjectGet(name,OBJPROP_PRICE1));

   text=ObjectDescription(name);
   ccolor=(color)ObjectGet(name,OBJPROP_COLOR);
   sizeFont=(string)ObjectGet(name,OBJPROP_FONTSIZE);
   angle=(string)ObjectGet(name,OBJPROP_ANGLE); //   

//---  
   string result=name+delimeter+
                 type+delimeter+
                 TimeToStr(time1)+delimeter+
                 price1+delimeter+
                 text+delimeter+
                 ColorToString(ccolor,true)+delimeter+
                 sizeFont+delimeter+
                 angle;

   return(result);
  }
//+------------------------------------------------------------------+

//+--------------------------------------------------------------2.0-+
//|     (LABEL_OBJ)               |
//+------------------------------------------------------------------+
string CObjecter::LabelObjectToString(string name,string delimeter="/")
  {
   string type,x,y,text,sizeFont,angle,corner;
   color ccolor=clrRed;

   type=IntegerToString(ObjectType(name));
   x = (string)ObjectGet(name, OBJPROP_XDISTANCE);
   y = (string)ObjectGet(name, OBJPROP_YDISTANCE);

   text=ObjectDescription(name);
   ccolor=(color)ObjectGet(name,OBJPROP_COLOR);
   sizeFont=(string)ObjectGet(name,OBJPROP_FONTSIZE);
   angle=(string)ObjectGet(name,OBJPROP_ANGLE); //   
   corner=(string)ObjectGet(name,OBJPROP_CORNER); //    

//---  
   string result=name+delimeter+
                 type+delimeter+
                 x+delimeter+
                 y+delimeter+
                 text+delimeter+
                 ColorToString(ccolor)+delimeter+
                 sizeFont+delimeter+
                 angle+delimeter+
                 corner;

   return(result);
  }
//+------------------------------------------------------------------+

//--- 2.1 
//+------------------------------------------------------------------+
//|     (LABEL_OBJ)               |
//+------------------------------------------------------------------+
string CObjecter::ObjectToString(long chartID,string name,string delimeter="/")
  {

   string result="";
   if(ObjectFind(chartID,name)==-1)
     {
      Print(__FUNCTION__+".   : "+name+"  .");
      return (result);
     }
   else
     {

      ResetLastError();
      Print(__FUNCTION__+".   : "+name+" !.");
     }

//--- String's

// ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_NAME)+delimeter;
// Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
// ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_TEXT)+delimeter;
// Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
// ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_TOOLTIP)+delimeter;
// Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
// ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_LEVELTEXT)+delimeter;
//  Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
//  ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_FONT)+delimeter;
//Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
// ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_BMPFILE)+delimeter;
//Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());
//ResetLastError();
   result=result+ObjectGetString(0,name,OBJPROP_SYMBOL)+delimeter;
//Print(__FUNCTION__+" "+__LINE__+" :"+GetLastError());

//--- Integer's
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_COLOR))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_STYLE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_WIDTH))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_BACK))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_ZORDER))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_FILL))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_HIDDEN))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_SELECTED))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_READONLY))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_TYPE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_TIME,0))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_TIME,1))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_TIME,2))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_SELECTABLE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_CREATETIME))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_LEVELS))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_LEVELCOLOR))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_LEVELSTYLE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_LEVELWIDTH))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_ALIGN))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_FONTSIZE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_RAY_RIGHT))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_RAY))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_ELLIPSE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_ARROWCODE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_TIMEFRAMES))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_ANCHOR))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_XDISTANCE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_YDISTANCE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_STATE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_CHART_ID))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_XSIZE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_YSIZE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_XOFFSET))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_YOFFSET))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_PERIOD))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_DATE_SCALE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_PRICE_SCALE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_CHART_SCALE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_BGCOLOR))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_CORNER))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_BORDER_TYPE))+delimeter;
   result=result+IntegerToString(ObjectGetInteger(chartID,name,OBJPROP_BORDER_COLOR))+delimeter;

//--- Double's
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_PRICE,0),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_PRICE,1),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_PRICE,2),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_LEVELVALUE),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_SCALE),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_ANGLE),Digits())+delimeter;
   result=result+DoubleToString(ObjectGetDouble(chartID,name,OBJPROP_DEVIATION),Digits())+delimeter;
   Print(result);
   return(result);
  }
//+------------------------------------------------------------------+
